<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ================                             Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-surfbar_stats.php                           *
 * -------------------------------------------------------------------- *
 * Short description : Surfbar URL statistics                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : URL-Statistiken fuer die Surfbar                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Is the 'url_id' set?
if (isGetRequestElementSet(('url_id'))) {
	// Generate general statistics
	$result = SQL_QUERY_ESC("SELECT `userid`,`count` AS `total_visits`, UNIX_TIMESTAMP(`last_surfed`) AS `last_surfed`
FROM `{?_MYSQL_PREFIX?}_surfbar_stats`
WHERE `url_id`=%s
ORDER BY `userid` ASC",
	array(bigintval(getRequestElement('url_id'))), __FILE__, __LINE__);

	// Entries found?
	if (SQL_NUMROWS($result) > 0) {
		// Get all rows
		$OUT = ''; $SW = 2; $cnt = 0; $visits = 0;
		while ($content = SQL_FETCHARRAY($result)) {
			// Count totals
			$visits += $content['total_visits'];

			// "Translate" some data
			$content['userid']       = generateUserProfileLink($content['userid']);
			$content['total_visits'] = translateComma($content['total_visits']);
			$content['last_surfed']  = generateDateTime($content['last_surfed'], '2');
			$content['sw']           = $SW;

			// Load row template
			$OUT .= loadTemplate('admin_surfbar_url_stats_row', true, $content);
			$cnt++; $SW = 3 - $SW;
		} // END - while

		// Prepare content
		$content = array(
			'rows'    => $OUT,
			'userids' => $cnt,
			'visits'  => $visits
		);


		// Load main template
		loadTemplate('admin_surfbar_url_stats', false, $content);
	} else {
		// No statistics so far
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_NO_URL_STATS'));
	}
} else {
	// Generate general statistics
	$result = SQL_QUERY("SELECT
	`userid`, COUNT(`url_id`) AS `visited_urls`, SUM(`count`) AS `total_visits`
FROM
	`{?_MYSQL_PREFIX?}_surfbar_stats`
GROUP BY
	`userid`
ORDER BY
	`userid` ASC", __FILE__, __LINE__);

	// Entries found?
	if (SQL_NUMROWS($result) > 0) {
		// Get all rows
		$OUT = ''; $SW = 2; $urls = 0; $visits = 0;
		while ($content = SQL_FETCHARRAY($result)) {
			// Count totals
			$urls   += $content['visited_urls'];
			$visits += $content['total_visits'];

			// "Translate" some data
			$content['userid']       = generateUserProfileLink($content['userid']);
			$content['visited_urls'] = translateComma($content['visited_urls']);
			$content['total_visits'] = translateComma($content['total_visits']);
			$content['sw']           = $SW;

			// Load row template
			$OUT .= loadTemplate('admin_surfbar_stats_row', true, $content);
			$SW = 3 - $SW;
		} // END - while

		// Prepare content
		$content = array(
			'rows'   => $OUT,
			'urls'   => $urls,
			'visits' => $visits
		);


		// Load main template
		loadTemplate('admin_surfbar_stats', false, $content);
	} else {
		// No statistics so far
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_SURFBAR_NO_STATS'));
	}
}

// Free result
SQL_FREERESULT($result);

//
?>
