<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/14/2003 *
 * ===============                              Last change: 11/25/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mailid.php                                       *
 * -------------------------------------------------------------------- *
 * Short description : Confirmation file for emails                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bestaetigung von Mails                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Tell everyone we are in this module
$GLOBALS['module'] = 'mailid';
$GLOBALS['output_mode'] = 1;
$errorCode = '';

// Load the required file(s)
require('inc/config-global.php');

// Set content type
setContentType('text/html');

// Is the extension active?
redirectOnUninstalledExtension('mailid');

// Init
$url_userid = 0;
$url_bid = 0;
$url_mid = 0;

// Secure all data
if (isGetRequestElementSet('userid'))     $url_userid = bigintval(getRequestElement('userid'));
if (isGetRequestElementSet('mailid'))  $url_mid = bigintval(getRequestElement('mailid'));
if (isGetRequestElementSet('bonusid')) $url_bid = bigintval(getRequestElement('bonusid'));

// 01        1        12            3    32           21    1                   22     10
if (($url_userid) > 0 && (($url_mid > 0) || ($url_bid > 0)) && (getTotalFatalErrors() == 0)) {
	// Maybe he wants to confirm an email?
	if ($url_mid > 0) {
		// Normal-Mails
		$result = SQL_QUERY_ESC("SELECT `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `stats_id`=%s AND `userid`=%s LIMIT 1",
			array($url_mid, $url_userid), __FILE__, __LINE__);
		$type = 'mailid'; $urlId = $url_mid;
	} elseif ($url_bid > 0) {
		// Bonus-Mail
		$result = SQL_QUERY_ESC("SELECT `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `bonus_id`=%s AND `userid`=%s LIMIT 1",
			array($url_bid, $url_userid), __FILE__, __LINE__);
		$type = 'bonusid'; $urlId = $url_bid;
	} else {
		// Problem: No ID entered
		redirectToUrl('index.php');
	}

	if (SQL_NUMROWS($result) == 1) {
		// Load the entry
		list($ltype) = SQL_FETCHROW($result);

		// Clean result
		SQL_FREERESULT($result);

		// @TODO Rewrite this to a filter
		switch ($ltype)
		{
			case 'NORMAL':
				// Is the stats ID valid?
				$result = SQL_QUERY_ESC("SELECT pool_id, url, subject FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `id`=%s LIMIT 1",
				array($url_mid), __FILE__, __LINE__);
				break;

			case 'BONUS':
				// Is the bonus extension active?
				redirectOnUninstalledExtension('bonus');

				// Bonus-Mails
				$result = SQL_QUERY_ESC("SELECT id, url, subject FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
				array($url_bid), __FILE__, __LINE__);
				break;

			default: // Invalid mail type
				debug_report_bug('Invalid mail type ' . $ltype . ' detected.');
				break;
		}

		if (SQL_NUMROWS($result) == 1) {
			// Load data
			list($pool, $URL, $title) = SQL_FETCHROW($result);

			// Free result
			SQL_FREERESULT($result);

			// Set it
			setExtraTitle($title);

			// Is the user's ID unlocked?
			$result = SQL_QUERY_ESC("SELECT `status`, `gender`, `surname`, `family` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
				array($url_userid), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				list($status, $gender, $surname, $family) = SQL_FETCHROW($result);
				SQL_FREERESULT($result);
				if ($status == 'CONFIRMED') {
					// User has confirmed his account so we can procede...
					// @TODO Rewrite this to a filter
					switch ($ltype)
					{
						case 'NORMAL':
							$result = SQL_QUERY_ESC("SELECT payment_id FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s LIMIT 1",
								array(bigintval($pool)), __FILE__, __LINE__);
							if (SQL_NUMROWS($result) == 1) {
								list($pay) = SQL_FETCHROW($result);
								$time      = getPaymentPoints($pay, 'time');
								$payment   = getPaymentPoints($pay, 'payment');
								$isValid   = true;
							} // END - if

							// Free memory
							SQL_FREERESULT($result);
							break;

						case 'BONUS':
							$result = SQL_QUERY_ESC("SELECT points, time FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
								array($url_bid), __FILE__, __LINE__);
							if (SQL_NUMROWS($result) == 1) {
								list($points, $time) = SQL_FETCHROW($result);
								$payment = '0.00000';
								$isValid = true;
							}

							// Free memory
							SQL_FREERESULT($result);
							break;

						default: // Invalid mail type
							debug_report_bug('Invalid mail type ' . $ltype . ' detected.');
							break;
					}

					// Add header
					loadIncludeOnce('inc/header.php');

					// Was that mail a valid one?
					if ($isValid === true) {
						// If time is zero seconds we have a sponsor mail. 1 Second shall be set to avoid problems
						if (($time == '0') && ($payment > 0)) { $URL = getConfig('URL'); $time = '1'; }
						if (($time > 0) && (($payment > 0) || ($points > 0))) {
							// Export data into constants for the template
							$content = array(
								'userid'  => $url_userid,
								'type' => $type,
								'data' => $urlId,
								'url'  => generateDerefererUrl($URL)
							);

							// Load template
							loadTemplate('mailid_frames', false, $content);
						} else {
							$errorCode = getCode('DATA_INVALID');
						}
					} else {
						$errorCode = getCode('POSSIBLE_INVALID');
					}
				} else {
					$errorCode = getCode('ACCOUNT_LOCKED');
				}
			} else {
				SQL_FREERESULT($result);
				$errorCode = getCode('USER_404');
			}
		} else {
			SQL_FREERESULT($result);
			$errorCode = getCode('STATS_404');
		}
	} else {
		SQL_FREERESULT($result);
		$errorCode = getCode('ALREADY_CONFIRMED');
	}
} else {
	// Nothing entered
	$errorCode = getCode('ERROR_MAILID');
}

// Error code is set?
if (!empty($errorCode)) {
	// @TODO Rewrite this to a dynamic include or so
	switch (getConfig('mailid_error_redirect')) {
		case 'INDEX': // Redirect to index page
			redirectToUrl('modules.php?module=index&amp;code=' . $errorCode . '&amp;ext=mailid');
			break;

		case 'REJECT': // Redirect to rejection page
			if (isExtensionActive('other')) {
				// Redirect to configured URL
				redirectToConfiguredUrl('reject_url');
			} else {
				// Redirect to index
				redirectToUrl('index.php');
			}
			break;

		default:
			logDebugMessage(__FILE__, __LINE__, sprintf("Unknown status %s detected in mailid_error_redirect.", getConfig('mailid_error_redirect')));
			redirectToUrl('modules.php?module=index&amp;code=' . getCode('UNKNOWN_STATUS') . '&amp;ext=mailid');
			break;
	} // END - switch
} // END - if

// Include footer
loadIncludeOnce('inc/footer.php');

// [EOF]
?>
